unit Ucode;
(*
CODMESS (c) 9/1/2000, Fleury, Jean Claude Meier

  Site   http://www.respublica.fr/jcmeier
  E-mail j-c.meier@ac-nancy-metz.fr

  Little tool to easily crypt messages inside the .exe file, to prevent or at least
  make more difficult hacking with hexadecimal editors.
  Messages are typed, automatically crypted and copied in the clipboard to be
  inserted in the source by pasting. The uncrypt procedure can also be added,
  if needed.

  Give a look at the Activate procedure of this soft itself to see an example.

  For a best use of this soft, Add it in the Outils menu of delphi (Options,
  Outils, Add...)

  It's not absolutly safe because uncrypt procedure and key are inserted in the
  .exe file. But to make still more difficult messages modifications, why not use
  keys like:  FF0AD3C5 ou bkOK, clBlack, OnClick,... that must be a bit difficult
  to find in the binary source (?).

  This soft is freeware and the source is given. You can use and modify it as you
  want but at your risks and perils (:-).

*)
interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Buttons;

type
  TCodeForm = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    Edit5: TEdit;
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    Button1: TButton;
    CheckBox1: TCheckBox;
    ListBox1: TListBox;
    BitBtn3: TBitBtn;
    ECle: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure ECleChange(Sender: TObject);
    procedure ECleEnter(Sender: TObject);
    procedure Edit1Enter(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private-dclarations }
  public
    { Public-dclarations }
  end;

var
  CodeForm: TCodeForm;

implementation

{$R *.DFM}

Const ajoute_proc : boolean = false;

 cle : String = ''; (* the crypt key : string, 20 car max *)

Function encode(ch_cle, ch_entree : STRING) : string;
VAR
  long, i, j : BYTE;
  ch_sortie : STRING;
BEGIN
  long := Length(ch_cle) DIV 2;
  j := 1;
  i := 1;
  ch_sortie := '';
  REPEAT
    ch_sortie := ch_sortie + Chr(Ord(ch_cle[i]) + Ord(ch_entree[j]) + long);
    Inc(j);
    Inc(i);
    IF i > Length(ch_cle) THEN i := 1;
  UNTIL j > Length(ch_entree);
  result := ch_sortie;
END;
(* Uncrypt this proc is inserted in the invisible listbox1   *)
Function decode(ch_cle, ch_entree : STRING) : String;
VAR
  long, i, j : BYTE;
  ch_sortie : STRING;
BEGIN
  long := Length(ch_cle) DIV 2;
  j := 1;
  i := 1;
  ch_sortie := '';
  REPEAT
    ch_sortie := ch_sortie + Chr(Ord(ch_entree[j]) - Ord(ch_cle[i]) - long);
    Inc(j);
    Inc(i);
    IF i > Length(ch_cle) THEN i := 1;
  UNTIL j > Length(ch_entree);
  result := ch_sortie;
END;

(* Crypt the message et save it to disk *)
procedure TCodeForm.BitBtn1Click(Sender: TObject);
Var fich  : System.text;
    Ch_Donnee, Ch_Codee : ARRAY[1..5] of string;
    i : byte;
Begin
  AssignFile(fich,'CODE.DTA');
  Rewrite(fich);

  Ch_donnee[1] := Edit1.text;
  Ch_donnee[2] := Edit2.text;
  Ch_donnee[3] := Edit3.text;
  Ch_donnee[4] := Edit4.text;
  Ch_donnee[5] := Edit5.text;

  WriteLn(fich,'CONST');
  WriteLn(fich,'   cle = '''+cle+''';');
  FOR i := 1 TO 5 DO if ch_donnee[i] <> '' then
  begin
    WriteLn(fich,'  (* mess'+inttostr(i)+' = '''+Ch_donnee[i]+''' *)');
    WriteLn(fich,'  _mess'+inttostr(i)+' = '''+encode(cle,Ch_donnee[i])+''';');
  end;
  CloseFile(fich);
  Memo1.Lines.LoadFromfile('CODE.DTA');
  Memo1.lines.Add('');
  if ajoute_proc then
  for i := 0 to Listbox1.Items.Count-1 do
  Memo1.Lines.Add(Listbox1.Items[i]);
  Button1.Enabled := True;
end;
(* Copy to clipboard *)
procedure TCodeForm.Button1Click(Sender: TObject);
begin
   Memo1.SelectAll;
   Memo1.CutToClipboard;
   Button1.Enabled := False;
end;
(* Add or no the uncrypt proc : necessity to crypt again *)
procedure TCodeForm.CheckBox1Click(Sender: TObject);
begin
  Ajoute_proc := CheckBox1.Checked;
  Memo1.Clear;
  Button1.Enabled := False;
end;

(* Load precedent message from disk, eventually to correct it *)
procedure TCodeForm.BitBtn3Click(Sender: TObject);
begin
  Memo1.Lines.LoadFromFile('CODE.DTA');
  Memo1.Lines.Add('');
end;
(* To get the key *)
procedure TCodeForm.ECleChange(Sender: TObject);
begin
  if Ecle.Text <> '' then
  begin
    cle := Ecle.Text;
  end;
  Bitbtn1.Enabled := Ecle.Text <> '';
end;

(* Key modified : necessity to crypt again *)
procedure TCodeForm.ECleEnter(Sender: TObject);
begin
  Memo1.Clear;
  Button1.Enabled := False;
end;
(* messages modified : necessity to crypt again *)
procedure TCodeForm.Edit1Enter(Sender: TObject);
begin
  Memo1.Clear;
  Button1.Enabled := False;
end;

procedure TCodeForm.FormActivate(Sender: TObject);
CONST
   cle = '0AFFD3E4';
  (* mess1 = 'To crypt  messages in the .exe  V. 2.0  1/2000, Fleury, JC Meier' *)
  _mess1 = 'jTejWexiXsj|vgiTvy|xgydTdTj';
  (* mess2 = 'Freeware' *)
  _mess2 = 'z';
begin
  Caption := decode(cle,_mess1);
  Label2.Caption := decode(cle,_mess2);
end;

end.
